/// <reference types="node" />
import { AsyncLocalStorage } from 'async_hooks';
import { BaseModelMiddlewareParams, BaseModelQueryContext } from './model-middleware';
export declare class BaseModelMiddlewareRoleAbilityLog {
    private static self;
    private readonly devMode;
    private readonly idToken;
    private readonly identityUrl;
    private readonly disbaleLogMessage;
    private constructor();
    static init(devMode: boolean, idToken: string, identityUrl: string, disbaleLogMessage: boolean): BaseModelMiddlewareRoleAbilityLog;
    static get isEnabled(): boolean;
    static get instance(): BaseModelMiddlewareRoleAbilityLog;
    process(params: BaseModelMiddlewareParams, next: any, asyncLocalStorage: AsyncLocalStorage<BaseModelQueryContext>): Promise<any>;
    private track;
    private trackUpsert;
    private trackFind;
    private trackCreate;
    private trackUpdate;
    private trackDelete;
    private callRoleModelAbilityLog;
}
