import { AccessInfo } from '../auth';
export declare class BaseService<Browse, Read, Edit, Add, Delete, Activate, Deactivate> {
    private readonly BASE_SERVICE_LOG;
    private readonly entityName;
    readonly model: any;
    readonly schemaBrowse: any;
    readonly schemaRead: any;
    readonly schemaEdit: any;
    readonly schemaAdd: any;
    readonly schemaDelete: any;
    readonly schemaActivate: any;
    readonly schemaDeactivate: any;
    constructor({ entityName, model, schemaBrowse, schemaRead, schemaEdit, schemaAdd, schemaDelete, schemaActivate, schemaDeactivate }: {
        entityName: any;
        model: any;
        schemaBrowse: any;
        schemaRead: any;
        schemaEdit: any;
        schemaAdd: any;
        schemaDelete: any;
        schemaActivate: any;
        schemaDeactivate: any;
    });
    browse(params: Browse, accessInfo: AccessInfo): Promise<any>;
    read(params: Read, accessInfo: AccessInfo): Promise<any>;
    edit(params: Edit, accessInfo: AccessInfo): Promise<any>;
    add(params: Add, accessInfo: AccessInfo): Promise<any>;
    delete(params: Delete, accessInfo: AccessInfo): Promise<any>;
    activate(params: Activate, accessInfo: AccessInfo): Promise<any>;
    deactivate(params: Deactivate, accessInfo: AccessInfo): Promise<any>;
}
